local debug=function(arg) if type(arg)=='table' then print(serpent.block(arg)) else  print(arg) end end

remote.add_interface('liftoff', {
	info=function()
		print('liftoff speeds')
		for k,v in pairs(global.def) do 
			game.player.print(k..' speed: '..v.v..' runway lenght: '..v.s)
		end
	end,
})

require 'planes'
script.on_init(function() init() end)
script.on_configuration_changed(function() init() end)

function init()
	global.planes=global.planes or {--[[
		[i]={
		[1]=entity,
		[2]=grounded,
		[3]=float(runway_covered),
		[4]=int(heigth)
		}
	]]}--table to keep track of vehicles capable of flying
	global.pilots=global.pilots or {--[[
		[player.index]={
			veh=entity,
			speed=gui_handle, 
			height=gui_handle,
			data=reference_to_global_planes,
			}
	]]}--a table to keep track of players that are inside of vehicles, should be always updated with almost freshest reference to plane
	global.falling=global.falling or {--[[
		[player.index]={
			[1]=velocity,
			[2]=direction_cos
			[3]=direction_sin
		}
	]]}--keeps track of velocity at which player is flinged if out of plane at full speed
	global.def=global.def or {--[[
		[entity.name]={
			grounded=grounded_dummy_entity.name,
			v=liftoff_speed,
			s=runway_length,
			shadow=shadow_entity.name,
		}
	]]}--values often needed for updates
	global.fed= global.fed or {--[[
		[grounded_entity.name]=entity.name
	]]}
	global.edf= global.edf or {--[[
		[shadow_entity.name]=entity.name
	]]}
	for _,p in pairs(game.entity_prototypes) do
		if p.type=='car' and string.find(p.name,"#grounded#") then
			--local _,_,speed,speed2,name=string.find(p.name,"#grounded#(%d+)#(%d+)#(.+)")--thi is not used 
			local _,_,name=string.find(p.name,"#grounded#(.+)")
			if not (name and planes_definition[name]) then
				log"Litoff mod warning"
				log"There was error processing entity"
				log(p.name)
			else
				global.def[name]={
					grounded=p.name,
					shadow="#shadow#"..name,
					v=planes_definition[name].lift_velocity,
					s=planes_definition[name].runway_length, 
					}
			end
		end
	end
	for k,v in pairs(global.def) do
		global.fed[v.grounded]=k
		global.edf[v.shadow]=k
	end
end

function place(e,new_name)
	g=e.surface.create_entity{name=new_name,position=e.position,force='neutral'}
	g.insert("dummy-plane-fuel")
	g.orientation=e.orientation
	g.speed=e.speed
	g.minable=false
	g.operable=false
	g.riding_state=e.riding_state
	return g
end


function onbuilt(ev)
	local e=ev.created_entity
	if global.def[e.name] then
		--if e.surface.can_place_entity{name="car",position=e.position} then--no other fix for equipment disappearance
			local d=global.def[e.name]
			g=place(e,d.grounded)
			g.force="neutral"
			table.insert(global.planes,{e,g,global.def[e.name].s,0})
			--debug('built')
			--debug(global.def[e.name].s)
		--else
			--game.players[ev.player_index].insert(e.name)
			--e.destroy()
		--end
	end
end
script.on_event(defines.events.on_built_entity,onbuilt)--car cannot be built by robots

function find(t,field,e)
	for i=1,#t do if t[i][field]==e then return i end end
end
script.on_event(defines.events.on_entity_died,function(ev)
	local e=ev.entity
	if global.def[e.name] or global.fed[e.name] then
		local ind=(global.def[e.name] and 1) or 2
		local g=global.planes
		local j=find(g,ind,e)
		if j then
			if g[j][3-ind].valid then
				g[j][3-ind].die()
			end
			table.remove(g,j) 
		end
	end
end)
script.on_event({defines.events.on_robot_pre_mined_item,defines.events.on_preplayer_mined_item,},function(ev)
	local e=ev.entity
	if global.def[e.name] then
		local g=global.planes
		local j=find(g,1,e)
		if not j then return end
		g[j][2].destroy()
		table.remove(g,j) 
	end
end)

script.on_event(defines.events.on_player_driving_changed_state,
function(ev)
	local pindex=ev.player_index
	local p=game.players[ev.player_index]
	if p.vehicle then
		local name=p.vehicle.name
		if global.fed[name] then
			local j=find(global.planes,2,p.vehicle)
			global.planes[j][1].passenger=p.character
			game.raise_event(defines.events.on_player_driving_changed_state,ev)
		end
		if global.def[name] then 
			--debug('guing')
			if not find(global.planes,1,p.vehicle) then --if plane was built before installing mod
				onbuilt({created_entity=p.vehicle})
			end
			local gui=p.gui.top.add{type='frame',direction='vertical',name='liftoff'}
			local spmeter=gui.add{type='flow',name='speedometer',direction='horizontal'}
			spmeter.add{type='label',name='text', caption={'speed'}}
			local spv=spmeter.add{type='progressbar',size=1}
			local altmeter=gui.add{type='flow',name='altmeter',direction='horizontal'}
			altmeter.add{type='label',name='text', caption={'height'}}
			local alv=altmeter.add{type='progressbar',size=1}
			global.pilots[pindex]={
				veh=p.vehicle,
				speed=spv,
				height=alv,
				data=global.planes[find(global.planes,1,p.vehicle)]
				}
		elseif global.edf[p.vehicle.name] then
			p.vehicle.passenger=nil
			game.raise_event(defines.events.on_player_driving_changed_state,ev)
		end
	elseif global.pilots[pindex] then
		local veh= global.pilots[pindex].veh
		if veh.valid then
			ori=veh.orientation
			--debug(ori)
			--debug(math.sin(ori*math.pi*2))
			--debug(math.cos(ori*math.pi*2))
			global.falling[pindex]={veh.speed,math.sin(veh.orientation*math.pi*2),-math.cos(veh.orientation*math.pi*2)}
		end
		p.gui.top.liftoff.destroy()
		global.pilots[pindex]=nil
	end
end)

script.on_event(defines.events.on_player_left_game,
function(ev)
	local pindex=ev.player_index
	--global.pilots[pindex]=nil
	global.falling[pindex]=nil
end)

local floor= math.floor
local round=function (num)
	return floor(num+0.5)
end
local accelerating=defines.riding.acceleration.accelerating

script.on_event(defines.events.on_tick,
function(ev)
	--update planes
	local g=global.planes
	local def=global.def
	for i=#g,1,-1 do
		local d=g[i]
		local e=d[1]
		local g=d[2]
		if not e.valid then--people just have to break stuff that's not theirs, don't they?
			if g.valid then g.die() 
			else table.remove(g,i) end
			goto next_plane
		end 
		if not g.valid then--just in case someone feels particularly savage
			g=place(e,par.shadow)
			d[2]=g
			g.destructible=false
			d[4]=2
		end
		local par=def[e.name]
		if not par then error("No parameters for entity "..e.name) end
		--local d4=d[4]
		--grounded behavior
		if d[4]==0 then
			--collision check
			local ep, gp = e.position, g.position
			if (ep.x~=gp.x) or (ep.y~=gp.y) then
				--debug("oh shoot we hit something!")
				--die in water
				if e.surface.get_tile(gp.x,gp.y).collides_with("water-tile") then
					if e.passenger then
						p=e.passenger
						e.passenger=nil
						if p.destructible then p.die() end
					end
					e.speed=1
					e.die()
					goto next_plane
				elseif g.energy==0 or e.energy==0 then
					--if dummy fuel has expired
					g.insert('dummy-plane-fuel')
					g.teleport(e.position)
				else
					--collision
					e.teleport(g.position)
					e.health=g.health
					e.speed=g.speed
				end
			--another if is merged to the above, it is not particularly related, but it is needed to evade invalid entity checks
			end
			if e.speed>par.v then--begin takeoff
				--debug('pulling')
				d[3]=d[3]-e.speed
				if d[3]<0 then
					--debug('pulled')
					--take off
					g.destroy()
					g=place(e,par.shadow)
					d[2]=g
					g.destructible=false
					d[4]=2
				end
				--debug(d[3])
			elseif d[3]<par.s then--too slow, inertia
				--debug('soslow')
				d[3]=d[3]+par.v
				local sp, v=e.speed, par.v*.9
				e.speed=( sp>v ) and sp or v
				g.speed=e.speed
			else --d[3]>par.s and e.speed<par.v --plane can stop now
				--debug("regain control")
				--debug('that was slow')
				d[3]=par.s
			end
		elseif d[4]<360 then
			--perform altitude change
			if e.speed>par.v then
				g.teleport({e.position.x+0.005*d[4],e.position.y+.01*d[4]})
				d[4]=d[4]+1
			elseif e.riding_state.acceleration~=accelerating then
				d[4]=d[4]-1
				--debug('going down')
				e.speed=par.v*.9
				g.speed=e.speed
				g.teleport({e.position.x+0.005*d[4],e.position.y+.01*d[4]})
			end
			if e.energy==0 then g.teleport({e.position.x+0.005*d[4],e.position.y+.01*d[4]}) end
			--landing
			if d[4]==1 then
				g.destroy()
				g=place(e,par.grounded)
				g.force="neutral"
				d[2]=g
				d[4]=0
			end
		else
			--keep high
			if e.speed<par.v then
				d[4]=d[4]-1
			end
		end
		if e.valid and g.valid then
			--make shadow follow
			g.riding_state=e.riding_state
			g.health=e.health
			g.orientation=e.orientation
		end
		::next_plane::
	end--for i=1,#g do
	--update falling players
	local f=global.falling
	--if ev.tick%10==0 and next(f)  then
	if  next(f)  then
		for pindex,tuple in pairs(f) do
			local p=game.players[pindex]
			if (p.valid and p.connected and p.character and p.character.valid) then 
				local v=tuple[1]
				local sin,cos=tuple[2],tuple[3]
				local x,y=p.position.x, p.position.y
				local dx,dy=sin*v*2,cos*v*2
				local pos={x+dx,y+dy}
				if p.surface.can_place_entity{name="player",position=pos} then p.teleport(pos) end
				p.character.damage(v*v*10,'neutral','impact')
				if ev.tick%100==0 then p.character.damage(v*v*1000,'neutral','impact') end
				tuple[1]=v*.92
				if v<0.01 then f[pindex]=nil end
			end
		end
	end
	--update pilot gui
	if ev.tick%30==0 then
		--debug('gui')
		--debug(global.pilots)
		for i,pilot in pairs(global.pilots) do
			local p=game.players[i]
			--debug(p.index)
			--debug(p.valid)
			--debug(p.connected)
			if p.valid and p.connected then
				if p.vehicle then 
					--debug('updating')
					--debug(p.vehicle.speed/def[p.vehicle.name].v)
					pilot.speed.value=p.vehicle.speed/def[p.vehicle.name].v
					pilot.height.value=pilot.data[4]/360
				else
					p.gui.top.liftoff.destroy()
					global.pilots[p.index]=nil
				end
			end
		end
	end
end)
remote.add_interface("Liftoff_replacement", { 
	on_entity_replaced = function(event)  
		if event.new_entity and event.new_entity.valid and event.old_entity and event.old_entity.valid then
			local e=event.old_entity
			if global.fed[e.name] then error"Don't touch my shit" end --I really don't know what else to do.
			if global.def[e.name]  then
				local g=global.planes
				local j=find(g,1,e)
				if j then
					g[j][1]=event.new_entity
					local d=global.def
					d[event.new_entity.name]=d[event.new_entity.name] or d[e.name]
				end
			end
			if global.fed[e.name] or global.def[e.name] then
				log("AAI is destroying things again, this time:")
				log("tick: "..game.tick)
				log("name: "..e.name)
			end
		end
	end
})
--script.on_event(defines.events, function(e)  print(e.name)  end)
				--{	new_entity = entity, 
					--new_entity_unit_number = entity.unit_number, 
					--old_entity = source_entity, 
					--old_entity_unit_number = source_entity.unit_number})
